-- WikNukem Forever
-- Copyright (C) 2009 Noé Falzon <firstname.lastname@aliceadsl.fr>

-- This program is  free software:  you can redistribute it and/or modify it
-- under  the terms  of the  GNU General Public License  as published by the
-- Free Software Foundation, version 3 of the License.
--
-- This program  is  distributed  in the hope  that it will  be useful,  but
-- WITHOUT  ANY WARRANTY;  without  even the implied  warranty of MERCHANTA-
-- BILITY  or  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
-- License for more details.
--
-- You should have received a copy of the  GNU General Public License  along
-- with this program. If not, see <http://www.gnu.org/licenses/>.

require "evol"

function blit(str,x,y,centered,fg,bg, transpkey)
	local u,v = math.floor(x),math.floor(y)
	--local u,v = x,y
	
	local lines = {}
	
	
	for line in str:gmatch("[^\n]+") do
		table.insert(lines,line)
	end
	
	if centered then
		u = u -#(lines[1])/2
		v = v - #lines/2
	end
	
	for i,line in ipairs(lines) do
		evol.curses.print(line, u, v+i-1, transpkey)
	end
	
	if fg or bg then
		for j,line in ipairs(lines) do
			for i = 1,#line do
				if line:sub(i,i) ~= transpkey then
					evol.curses.fill({u+i-1,v+j-1,1,1},nil,fg,bg)
				end
			end
		end
		
	end
end

function spritesize(str)
	local lines = {}
	
	for line in str:gmatch("[^\n]+") do
		table.insert(lines,line)
	end
	
	return #lines[1], #lines
end

hsv2rgb = function(h,s,v)

	local hi = math.floor(h/60) % 6
	local f = h/60 - math.floor(h/60)
	
	local p = v*(1-s)
	local q = v*(1-f*s)
	local t = v*(1-(1-f)*s)

	local r,g,b

	if hi == 0 then r,g,b = v,t,p
	elseif hi == 1 then r,g,b = q,v,p
	elseif hi == 2 then r,g,b = p,v,t
	elseif hi == 3 then r,g,b = p,q,v
	elseif hi == 4 then r,g,b = t,p,v
	elseif hi == 5 then r,g,b = v,p,q
	end
	
	return {r*255,g*255,b*255}
	
end
